$(() => {
    const errorHandling = function (jqXHR) {
        let status = parseInt(jqXHR.status);
        if (status == 403) {
            Popup.error('Недостаточно прав');
            return;
        }
        try {
            if (status != 400) throw null;
            let message = JSON.parse(jqXHR.responseText).message;
            if (!message) throw null;
            Popup.error(message);
        } catch (error) {
            Popup.error('Не удалось добавить токен');
        }
    };

    $('#createToken').click(function () {
        $(this).prop('disabled', true);
        
        $.getJSON(g_URLdir + 'handler/authTokens/create').success(result => {
            Popup.success('Токен добавлен');
            location.reload();
        }).fail(errorHandling).always(() => $(this).prop('disabled', false));
    });

    $('.officeList').on('click', '.deleteToken', function (event) {
        event.preventDefault();

        $(this).prop('disabled', true);

        let $body = $(this).parents('tbody');
        let $row = $(this).parents('tr');
        let token = $row.children('.token').text();

        $.getJSON(g_URLdir + 'handler/authTokens/delete/' + token).success(() => {
            $row.remove();
            if (!$body.children().length) $body.append('<tr><td colspan="6" class="empty">Нет записей</td></tr>');
            Popup.success('Токен удален');
        }).fail(errorHandling).always(() => $(this).prop('disabled', false));
    });
});